Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 69010)
+++ channels/chan_skinny.c	(working copy)
@@ -2308,7 +2331,6 @@
 	len = strlen(d->exten);
 
 	while (len < AST_MAX_EXTENSION-1) {
-
 		res = 1;  /* Assume we will get a digit */
 		while (strlen(d->exten) == len) {
 			ast_safe_sleep(c, loop_pause);
@@ -2358,6 +2380,7 @@
 			}
 		} else if (res == 0) {
 			ast_log(LOG_DEBUG, "Not enough digits (and no ambiguous match)...\n");
+			memset(d->exten, 0, sizeof(d->exten));
 			transmit_tone(s, SKINNY_REORDER);
 			if (sub->owner && sub->owner->_state != AST_STATE_UP) {
 				ast_indicate(c, -1);
@@ -2367,6 +2390,7 @@
 		} else if (!ast_canmatch_extension(c, c->context, d->exten, 1, c->cid.cid_num) &&
 			   ((d->exten[0] != '*') || (!ast_strlen_zero(d->exten) > 2))) {
 			ast_log(LOG_WARNING, "Can't match [%s] from '%s' in context %s\n", d->exten, c->cid.cid_num ? c->cid.cid_num : "<Unknown Caller>", c->context);
+			memset(d->exten, 0, sizeof(d->exten));
 			transmit_tone(s, SKINNY_REORDER);
 			/* hang out for 3 seconds to let congestion play */
 			ast_safe_sleep(c, 3000);
@@ -2382,6 +2406,7 @@
 	if (c)
 		ast_hangup(c);
 
+	memset(d->exten, 0, sizeof(d->exten));
 	return NULL;
 }
 
